#include <iostream>
#include <string>
#include <vector>  //A vectorok hasznlata miatt

using namespace std;

template<class Tipus>
Tipus nagyobb(Tipus a, Tipus b) {
	return a > b ? a : b;
}

int main ( int argc, char** argv ){

	//Template-ek hasznlata

	cout << "a 2, 9 maximuma: " << nagyobb<int>(2,9) << endl;
	cout << "a 10.0 , 30 maximuma: " << nagyobb<double>(10.0,30) << endl;
	cout << "a g,q maximuma: " << nagyobb<char>('g','q') << endl;
	cout << "a 'kulcslyuk', 'torta' maximuma: " << nagyobb<string>("kulcslyuk", "torta") << endl;


	//Vectorok hasznlata
	//A vector is template-et hasznl.
	vector<string> szavak;

	string szo("Csuklosbusz");
	string masik = "bicikli";

	szavak.push_back(szo);
	szavak.push_back(masik);
	szavak.push_back(string("Asvanyviz"));
	szavak.push_back("Csulok");

	//Jrjuk be ezt a kontnert
	for(vector<string>::iterator kezdet = szavak.begin(); kezdet != szavak.end(); ++kezdet){
		cout << "A vectorban levo egyik szo:" << *kezdet << endl;
	}

	return 0;
}